Index: FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMEXLI.m
===================================================================
--- FOIAVistA/trunk/r/CLINICAL_REMINDERS-PXRM/PXRMEXLI.m	(revision 631)
+++ FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMEXLI.m	(revision 636)
@@ -1,8 +1,11 @@
-PXRMEXLI ; SLC/PKR - List Manager routines for repository entry install. ;08/08/2007
- ;;2.0;CLINICAL REMINDERS;**6**;Feb 04, 2005;Build 123
+PXRMEXLI ; SLC/PKR - List Manager routines for repository entry install. ;01/10/2003
+ ;;2.0;CLINICAL REMINDERS;;Feb 04, 2005
  ;
  ;================================================
 INSALL ;Install all components in a repository entry.
  N IND,INSTALL
+ K ^TMP("PXRMEXIA",$J)
+ ;Set the install date and time.
+ S ^TMP("PXRMEXIA",$J,"DT")=$$NOW^XLFDT
  ;Initialize the name change storage.
  K PXRMNMCH
@@ -46,5 +49,4 @@
  I FILENUM=0 D
  . D RTNLD^PXRMEXIC(PXRMRIEN,START,END,.ATTR,.RTN)
- . D CHECKSUM^PXRMEXCS(.ATTR,START,END)
  . S ACTION=$$GETRACT^PXRMEXCF(.ATTR,.NEWNAME,.PXRMNMCH,.RTN,EXISTS)
  .;Save what was done for the installation summary.
@@ -56,6 +58,5 @@
  . I FIELDNUM=.001 S TEMP=^PXD(811.8,PXRMRIEN,100,(START+1),0)
  . S PT01=$P(TEMP,"~",2)
- . D SETATTR^PXRMEXFI(.ATTR,FILENUM,PT01)
- . D CHECKSUM^PXRMEXCS(.ATTR,START,END)
+ . D SETATTR^PXRMEXFI(.ATTR,FILENUM)
  . S ACTION=$$GETFACT^PXRMEXFI(PT01,.ATTR,.NEWPT01,.PXRMNMCH,EXISTS)
  .;Save what was done for the installation summary.
@@ -90,8 +91,13 @@
  I '$D(VALMY) Q
  ;
+ K ^TMP("PXRMEXIA",$J)
+ ;Set the install date and time.
+ S ^TMP("PXRMEXIA",$J,"DT")=$$NOW^XLFDT
+ ;
  ;Initialize the name change storage.
  K PXRMNMCH
  S (IND,INSTALL)=0
- F  S IND=$O(VALMY(IND)) Q:(+IND=0)!(PXRMDONE)  D INSCOM(IND,.INSTALL)
+ F  S IND=$O(VALMY(IND)) Q:(+IND=0)!(PXRMDONE)  D
+ .D INSCOM(IND,.INSTALL)
  ;
  ;If anything was installed rebuild the display.
@@ -109,8 +115,4 @@
  I '$D(^PXD(811.8,PXRMRIEN,120)) D CLIST^PXRMEXU1(.PXRMRIEN)
  I PXRMRIEN=-1 Q
- K ^TMP("PXRMEXIA",$J),^TMP("PXRMEXIAD",$J)
- ;Set the install date and time and type.
- S ^TMP("PXRMEXIA",$J,"DT")=$$NOW^XLFDT
- S ^TMP("PXRMEXIA",$J,"TYPE")="INTERACTIVE"
  ;Format the component list for display.
  D CDISP^PXRMEXLC(PXRMRIEN)
@@ -120,5 +122,4 @@
  Q
  ;
- ;================================================
  ;Exit action added to PXRM EXCH INSTALL MENU
 PEXIT ;PXRM EXCH INSTALL MENU protocol exit code
@@ -128,10 +129,8 @@
  Q
  ;
- ;================================================
 XQORM S XQORM("#")=$O(^ORD(101,"B","PXRM EXCH SELECT COMPONENT",0))_U_"1:"_VALMCNT
  S XQORM("A")="Select Action: "
  Q
  ;
- ;================================================
 XSEL ;PXRM EXCH SELECT COMPONENT validation
  N CNT,SELECT,SEL,PXRMDONE
@@ -140,10 +139,9 @@
  ;
  ;Sort selections into ascending sequence order
- D ORDER^PXRMEXLC(.SELECT,1)
+ D ORDER^PXRMEXLD(.SELECT,1)
  ;
- K ^TMP("PXRMEXIA",$J),^TMP("PXRMEXIAD",$J)
- ;Set the install date and time and type.
+ K ^TMP("PXRMEXIA",$J)
+ ;Set the install date and time.
  S ^TMP("PXRMEXIA",$J,"DT")=$$NOW^XLFDT
- S ^TMP("PXRMEXIA",$J,"TYPE")="INTERACTIVE"
  ;
  ;Install selected component
Index: FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMEXLM.m
===================================================================
--- FOIAVistA/trunk/r/CLINICAL_REMINDERS-PXRM/PXRMEXLM.m	(revision 631)
+++ FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMEXLM.m	(revision 636)
@@ -1,4 +1,4 @@
-PXRMEXLM ; SLC/PKR/PJH - Clinical Reminder Exchange List Manager routines. ;10/11/2007
- ;;2.0;CLINICAL REMINDERS;**4,6**;Feb 04, 2005;Build 123
+PXRMEXLM ; SLC/PKR/PJH - Clinical Reminder Exchange List Manager routines. ;12/22/2004
+ ;;2.0;CLINICAL REMINDERS;;Feb 04, 2005
  ;
  ;=====================================================
@@ -41,6 +41,23 @@
  ;
  ;=====================================================
+EN ;Main entry point for PXRM EXCHANGE
+ N PXRMDONE,PXRMNMCH
+ ;PXRMDONE is set to true if the user enters an action of Quit.
+ S PXRMDONE=0
+ ;PXRMNMCH is used to store name change information. If a finding
+ ;is copied to a new name or is replaced by another finding the
+ ;information is stored here. It is used when installing definitions
+ ;or dialogs so they use the new or replaced finding.
+ N VALMBCK,VALMSG,X,XMZ
+ S X="IORESET"
+ D ENDR^%ZISS
+ D BLDLIST^PXRMEXLC(0)
+ D EN^VALM("PXRM EX REMINDER EXCHANGE")
+ W IORESET
+ D KILL^%ZISS
+ Q
+ ;
+ ;=====================================================
 ENTRY ;Entry code
- D BLDLIST^PXRMEXLC(0)
  D XQORM
  Q
@@ -52,5 +69,4 @@
  K ^TMP("PXRMEXFND",$J)
  K ^TMP("PXRMEXIA",$J)
- K ^TMP("PXRMEXIAD",$J)
  K ^TMP("PXRMEXID",$J)
  K ^TMP("PXRMEXIH",$J)
@@ -166,27 +182,8 @@
  Q
  ;
- ;=====================================================
-START ;Main entry point for PXRM EXCHANGE
- N PXRMDONE,PXRMNMCH
- ;PXRMDONE is set to true if the user enters an action of Quit.
- S PXRMDONE=0
- ;PXRMNMCH is used to store name change information. If a finding
- ;is copied to a new name or is replaced by another finding the
- ;information is stored here. It is used when installing definitions
- ;or dialogs so they use the new or replaced finding.
- N VALMBCK,VALMSG,X,XMZ
- S X="IORESET"
- D ENDR^%ZISS
- D EN^VALM("PXRM EX REMINDER EXCHANGE")
- W IORESET
- D KILL^%ZISS
- Q
- ;
- ;=====================================================
 XQORM S XQORM("#")=$O(^ORD(101,"B","PXRM EXCH SELECT ENTRY",0))_U_"1:"_VALMCNT
  S XQORM("A")="Select Action: "
  Q
  ;
- ;=====================================================
 XSEL ;PXRM EXCH SELECT COMPONENT validation
  N SEL,PXRMRIEN
@@ -198,10 +195,10 @@
  .W $C(7),!,"Only one item number allowed." H 2
  .S VALMBCK="R"
- I ('SEL)!(SEL>VALMCNT)!('$D(@VALMAR@("SEL",SEL))) D  Q
+ I ('SEL)!(SEL>VALMCNT)!('$D(@VALMAR@("IDX",SEL))) D  Q
  .W $C(7),!,SEL_" is not a valid item number." H 2
  .S VALMBCK="R"
  ;
  ;Get the repository ien.
- S PXRMRIEN=^TMP("PXRMEXLR",$J,"SEL",SEL)
+ S PXRMRIEN=^TMP("PXRMEXLR",$J,"IDX",SEL,SEL)
  ;
  ;Full screen mode
@@ -233,10 +230,19 @@
  .;Rebuild the list for List Manager to display.
  .K ^TMP("PXRMEXLR",$J)
- .D REXL^PXRMLIST("PXRMEXLR")
- .S VALMCNT=^TMP("PXRMEXLR",$J,"VALMCNT")
+ .D RE^PXRMLIST(.RELIST,.IEN)
+ .M ^TMP("PXRMEXLR",$J)=RELIST
+ .S VALMCNT=RELIST("VALMCNT")
+ .F IND=1:1:VALMCNT D
+ ..S ^TMP("PXRMEXLR",$J,"IDX",IND,IND)=IEN(IND)
+ .;
  .S VALMHDR(1)="Deleted 1 exchange file entry",VALMHDR(2)=" ",VALMBCK="R"
  ;
- I OPTION="IH" D START^PXRMEXIH
- ;
- S VALMBCK="R"
- Q
+ I OPTION="IH" D
+ .N HISLIST,VALMCNT
+ .S HISLIST(SEL)=""
+ .D HISTLIST^PXRMEXLC(.HISLIST,.VALMCNT)
+ .D EN^VALM("PXRM EX INSTALLATION HISTORY")
+ .K ^TMP("PXRMEXIH",$J)
+ ;
+ S VALMBCK="R"
+ Q
Index: FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMEXLR.m
===================================================================
--- FOIAVistA/trunk/r/CLINICAL_REMINDERS-PXRM/PXRMEXLR.m	(revision 631)
+++ FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMEXLR.m	(revision 636)
@@ -1,4 +1,4 @@
-PXRMEXLR ; SLC/PKR/PJH - List Manager routines for existing repository entries. ;07/30/2007
- ;;2.0;CLINICAL REMINDERS;**6**;Feb 04, 2005;Build 123
+PXRMEXLR ; SLC/PKR/PJH - List Manager routines for existing repository entries. ;01/10/2003
+ ;;2.0;CLINICAL REMINDERS;;Feb 04, 2005
  ;==================================================
 CHF ;Create a host file containing repository entries.
@@ -50,5 +50,8 @@
  ;Rebuild the list for List Manager to display.
  K ^TMP("PXRMEXLR",$J)
- D REXL^PXRMLIST("PXRMEXLR")
+ D RE^PXRMLIST(.RELIST,.IEN)
+ M ^TMP("PXRMEXLR",$J)=RELIST
+ S VALMCNT=RELIST("VALMCNT")
+ F IND=1:1:VALMCNT S ^TMP("PXRMEXLR",$J,"IDX",IND,IND)=IEN(IND)
  ;
  S VALMHDR(1)="Deleted "_DELLIST("COUNT")_" Exchange File"
@@ -61,4 +64,28 @@
  ;
  ;==================================================
+DELHIST ;Get a list of repository installation entries and delete them.
+ ;Save the original list, it contains the selected repository entries.
+ N VALMYO
+ M VALMYO=VALMY
+ N IHIND,IND,RIEN,TEMP,VALMY
+ N VALMBG,VALMLST
+ ;
+ S VALMBG=1,VALMLST=+$O(^TMP("PXRMEXIH",$J,"IDX",""),-1)
+ ;Get the list to delete.
+ D EN^VALM2(XQORNOD(0))
+ ;If there is no list quit.
+ I '$D(VALMY) Q
+ S IND=""
+ F  S IND=$O(VALMY(IND)) Q:IND=""  D
+ . S TEMP=^TMP("PXRMEXIH",$J,"SEL",IND)
+ . S RIEN=$P(TEMP,U,1)
+ . S IHIND=$P(TEMP,U,2)
+ . D DELHIST^PXRMEXU1(RIEN,IHIND)
+ ;Rebuild the display list.
+ D HISTLIST^PXRMEXLC(.VALMYO,.VALMCNT)
+ S VALMBCK="R"
+ Q
+ ;
+ ;==================================================
 EXIT ; Exit code
  D CLEAN^VALM10
@@ -69,4 +96,85 @@
  ;
  ;==================================================
+IH ;Get a list of repository entries and show their installation history.
+ N VALMCNT,VALMY
+ D EN^VALM2(XQORNOD(0))
+ ;If there is no list quit.
+ I '$D(VALMY) Q
+ ;Build a history list.
+ D HISTLIST^PXRMEXLC(.VALMY,.VALMCNT)
+ D EN^VALM("PXRM EX INSTALLATION HISTORY")
+ K ^TMP("PXRMEXIH",$J)
+ S VALMBCK="R"
+ Q
+ ;
+ ;==================================================
+INDETAIL ;Output the details of an installation.
+ N VALMBG,VALMCNT,VALMHDR,VALMLST,VALMY
+ S VALMBG=1,VALMLST=+$O(^TMP("PXRMEXIH",$J,"IDX",""),-1)
+ ;Get the list to display.
+ D EN^VALM2(XQORNOD(0))
+ ;If there is no list quit.
+ I '$D(VALMY) Q
+ D INDISP(.VALMY)
+ Q
+ ;
+ ;==================================================
+INDISP(ARRAY) ;Display details list
+ N ACTION,CMPNT,DI,DP,ENTRY,IHIND,IND,INDEX,JND,KND
+ N NAME,NEWNAME,NLINE,RIEN,TEMP
+ K ^TMP("PXRMEXID",$J)
+ ;If there are no items then quit.
+ I '$D(ARRAY) Q
+ S (IND,NLINE)=0
+ F  S IND=$O(ARRAY(IND)) Q:IND=""  D
+ . S TEMP=^TMP("PXRMEXIH",$J,"SEL",IND)
+ . S RIEN=$P(TEMP,U,1)
+ . S IHIND=$P(TEMP,U,2)
+ . S TEMP=^PXD(811.8,RIEN,0)
+ . S ENTRY=$E($P(TEMP,U,1),1,38)
+ . S ENTRY=$$LJ^XLFSTR(ENTRY,38," ")
+ . S DP=$$FMTE^XLFDT($P(TEMP,U,3),"5Z")
+ . S DI=$$FMTE^XLFDT(^PXD(811.8,RIEN,130,IHIND,0),"5Z")
+ . I NLINE>1 D
+ .. S NLINE=NLINE+1
+ .. S ^TMP("PXRMEXID",$J,NLINE,0)="------------------------------------------------------------------------------"
+ . S NLINE=NLINE+1
+ . S ^TMP("PXRMEXID",$J,NLINE,0)=ENTRY_" "_DP_"  "_DI
+ .;Write the header line here.
+ . S NLINE=NLINE+1
+ . S ^TMP("PXRMEXID",$J,NLINE,0)="     Component                         Action  New Name"
+ . S CMPNT=""
+ . S JND=0
+ . F  S JND=$O(^PXD(811.8,RIEN,130,IHIND,1,JND)) Q:JND=""  D
+ .. S TEMP=^PXD(811.8,RIEN,130,IHIND,1,JND,0)
+ .. I $P(TEMP,U,2)'=CMPNT D
+ ... S NLINE=NLINE+1
+ ... S ^TMP("PXRMEXID",$J,NLINE,0)=" "
+ ... S CMPNT=$P(TEMP,U,2)
+ ... S NLINE=NLINE+1
+ ... S ^TMP("PXRMEXID",$J,NLINE,0)=CMPNT
+ .. S INDEX=$$RJ^XLFSTR($P(TEMP,U,1),4," ")
+ .. S NAME=$E($P(TEMP,U,3),1,36)
+ .. S NAME=$$LJ^XLFSTR(NAME,36," ")
+ .. S ACTION=$P(TEMP,U,4)
+ .. S NEWNAME=$E($P(TEMP,U,5),1,36)
+ .. S NEWNAME=$$LJ^XLFSTR(NEWNAME,36," ")
+ .. S NLINE=NLINE+1
+ .. S ^TMP("PXRMEXID",$J,NLINE,0)=INDEX_" "_NAME_" "_ACTION_"    "_NEWNAME
+ ..;If there are Additional Details add them to the display.
+ .. S KND=0
+ .. F  S KND=$O(^PXD(811.8,RIEN,130,IHIND,1,JND,1,KND)) Q:KND=""  D
+ ... S NLINE=NLINE+1
+ ... S ^TMP("PXRMEXID",$J,NLINE,0)=^PXD(811.8,RIEN,130,IHIND,1,JND,1,KND,0)
+ . S NLINE=NLINE+1
+ . S ^TMP("PXRMEXID",$J,NLINE,0)=" "
+ S VALMHDR(1)=^PXD(811.8,RIEN,0)_"  "_^TMP("PXRMEXID",$J,1,0)
+ S VALMCNT=NLINE
+ D EN^VALM("PXRM EX INSTALLATION DETAIL")
+ K ^TMP("PXRMEXID",$J)
+ S VALMBCK="R"
+ Q
+ ;
+ ;==================================================
 INSTALL ;Get a list of repository entries and install them.
  N IND,PXRMRIEN,VALMY
@@ -79,5 +187,5 @@
  F  S IND=$O(VALMY(IND)) Q:(+IND=0)!(PXRMDONE)  D
  .;Get the repository ien.
- . S PXRMRIEN=^TMP("PXRMEXLR",$J,"SEL",IND)
+ . S PXRMRIEN=^TMP("PXRMEXLR",$J,"IDX",IND,IND)
  .;The list template calls INSTALL^PXRMEXLI
  . D EN^VALM("PXRM EX LIST COMPONENTS")
@@ -98,4 +206,12 @@
  ;
  ;==================================================
+IS ;Get a list of packed reminders and print the installation summary.
+ N VALMY
+ D EN^VALM2(XQORNOD(0))
+ ;If there is no list quit.
+ I '$D(VALMY) Q
+ Q
+ ;
+ ;==================================================
 MIENLIST(LIST) ;Get a list of List Manager repository entries and turn it
  ;into iens.
@@ -108,6 +224,5 @@
  F  S IND=$O(VALMY(IND)) Q:+IND=0  D
  . S COUNT=COUNT+1
- . ;S IEN=^TMP("PXRMEXLR",$J,"IDX",IND,IND)
- . S IEN=^TMP("PXRMEXLR",$J,"SEL",IND)
+ . S IEN=^TMP("PXRMEXLR",$J,"IDX",IND,IND)
  . S LIST(IEN)=""
  S LIST("COUNT")=COUNT
@@ -117,4 +232,23 @@
 PEXIT ;PXRM EXCH INSTALLATION MENU protocol exit code
  S VALMSG="+ Next Screen   - Prev Screen   ?? More Actions"
- Q
- ;
+ ;Reset after page up/down etc
+ D XQORM
+ Q
+ ;
+ ;==================================================
+XQORM S XQORM("#")=$O(^ORD(101,"B","PXRM EXCH SELECT HISTORY",0))_U_"1:"_VALMCNT
+ S XQORM("A")="Select Action: "
+ Q
+ ;
+ ;==================================================
+XSEL ;PXRM EXCH SELECT HISTORY validation
+ N ARRAY,CNT,SELECT,SEL
+ S SELECT=$P(XQORNOD(0),"=",2)
+ I '$$VALID^PXRMEXLD(SELECT) S VALMBCK="R" Q
+ ;Build array of selected items
+ F CNT=1:1 S SEL=$P(SELECT,",",CNT) Q:'SEL  D
+ .S ARRAY(SEL)=""
+ ;
+ ;Display Selected Histories
+ D INDISP(.ARRAY)
+ Q
Index: FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMEXPR.m
===================================================================
--- FOIAVistA/trunk/r/CLINICAL_REMINDERS-PXRM/PXRMEXPR.m	(revision 631)
+++ FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMEXPR.m	(revision 636)
@@ -1,4 +1,4 @@
-PXRMEXPR ; SLC/PKR/PJH - Routines to create packed reminder definitions. ;12/12/2006
- ;;2.0;CLINICAL REMINDERS;**6**;Feb 04, 2005;Build 123
+PXRMEXPR ; SLC/PKR/PJH - Routines to create packed reminder definitions. ;02/25/2004
+ ;;2.0;CLINICAL REMINDERS;;Feb 04, 2005
  ;===============================================================
 ADDFILE(FLIST,ROOT,FILENAME) ;Add a file to the list of finding files.
@@ -29,6 +29,6 @@
  D GETSPON(811.9,RIEN,.SPONLIST)
  ;If there is a dialog add it.
- ;S DIEN=+$P($G(^PXD(811.9,RIEN,51)),U,1)
- ;I DIEN>0 D GETSPON(801.41,DIEN,.SPONLIST)
+ S DIEN=+$P($G(^PXD(811.9,RIEN,51)),U,1)
+ I DIEN>0 D GETSPON(801.41,DIEN,.SPONLIST)
  ;Go through the finding list to find additional sponsors.
  S IND=""
@@ -122,5 +122,5 @@
  ;Save the source information
  I +RTP'>0 Q
- K ^TMP(TMPIND,$J),^TMP("PXRMEXCS",$J)
+ K ^TMP(TMPIND,$J)
  D PUTSRC(RTP,TMPIND)
  ;
@@ -152,5 +152,5 @@
  ;If a dialog exists for this reminder add it and its findings to the
  ;list. Also collect any embedded TIU objects or templates
- D DIALOG^PXRMEXDG(RIEN,.DLGLIST,.FINDLIST,.OBJLIST,.TEMLIST,.SPONLIST)
+ D DIALOG^PXRMEXDG(RIEN,.DLGLIST,.FINDLIST,.OBJLIST,.TEMLIST)
  ;
  ;If there were education topics make sure subtopics are included.
@@ -226,4 +226,5 @@
  S LOC=$$SITE^VASITE
  S ^TMP(TMPIND,$J,"SRC","REMINDER")=$P(RTP,U,2)
+ ;S ^TMP(TMPIND,$J,"SRC","USER")=$P(^VA(200,DUZ,0),U,1)
  S ^TMP(TMPIND,$J,"SRC","USER")=$$GET1^DIQ(200,DUZ,.01)
  S ^TMP(TMPIND,$J,"SRC","SITE")=$P(LOC,U,2)
Index: FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMEXPU.m
===================================================================
--- FOIAVistA/trunk/r/CLINICAL_REMINDERS-PXRM/PXRMEXPU.m	(revision 631)
+++ FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMEXPU.m	(revision 636)
@@ -1,4 +1,4 @@
-PXRMEXPU ; SLC/PKR - Utilities for packing and unpacking repository entries. ;09/10/2007
- ;;2.0;CLINICAL REMINDERS;**6**;Feb 04, 2005;Build 123
+PXRMEXPU ; SLC/PKR - Utilities for packing and unpacking repository entries. ;12/22/2004
+ ;;2.0;CLINICAL REMINDERS;;Feb 04, 2005
  ;==================================================
 BTTABLE(DIQOUT,IENROOT,TTABLE) ;Build the DIQOUT to FDA iens translation table.
@@ -13,5 +13,5 @@
  . S TTABLE(FILENUM,IENS)="+"_IENS
  E  D  Q
- . W !,"BTTABLE^PXRMEXPU - DIQOUT problem, do not have correct top level"
+ . W !,"BTTABLE^PXRMEXPU - DIQOUT problem do not have correct top level"
  ;
  F  S FILENUM=$O(DIQOUT(FILENUM)) Q:FILENUM=""  D
@@ -43,6 +43,4 @@
  ... I '$D(TYPE(FILENUM,FIELD)) S TYPE(FILENUM,FIELD)=$$GET1^DID(FILENUM,FIELD,"","TYPE")
  ... S PTRTO=$S(TYPE(FILENUM,FIELD)="POINTER":$$GET1^DID(FILENUM,FIELD,"","POINTER"),1:"")
- ... ;Remove pointers to file 200.
- ... I PTRTO="VA(200," S DIQOUT(FILENUM,IENS,FIELD)="" Q
  ...;If the field's type is COMPUTED then don't transport it.
  ... I TYPE(FILENUM,FIELD)="COMPUTED" K DIQOUT(FILENUM,IENS,FIELD) Q
@@ -91,5 +89,5 @@
  ;==================================================
 GDIQF(LIST,NUM,TMPIND,SERROR) ;Save file entries into ^TMP(TMPIND,$J).
- N CSUM,DIQOUT,IENROOT,IND,FIELD,FILENAME,IENS,MSG,PT01,TEMP
+ N DIQOUT,IENROOT,IND,FIELD,FILENAME,IENS,MSG,PT01,TEMP
  S ^TMP(TMPIND,$J,"NUMF")=NUM
  F IND=1:1:NUM D
@@ -103,5 +101,5 @@
  . I $$FOKTI^PXRMEXFI(FILENUM) S FIELD="**"
  . E  S FIELD=.01
- . D GETS^DIQ(FILENUM,IEN,FIELD,"N","DIQOUT","MSG")
+ . D GETS^DIQ(FILENUM,IEN,FIELD,"","DIQOUT","MSG")
  . I $D(MSG) D  Q
  .. S SERROR=1,IND=NUM
@@ -117,6 +115,4 @@
  .;Convert the iens to the FDA adding form.
  . D CONTOFDA(.DIQOUT,.IENROOT)
- . S CSUM=$$DIQOUTCS^PXRMEXCS(.DIQOUT)
- . S ^TMP("PXRMEXCS",$J,IND,FILENAME)=CSUM
  .;Load the converted DIQOUT into TMP.
  . M ^TMP(TMPIND,$J,IND,FILENAME)=DIQOUT
@@ -135,5 +131,5 @@
  ;==================================================
 GRTN(LIST,NUM,TMPIND,SERROR) ;Save routines into ^TMP(TMPIND,$J).
- N DIF,IEN,IND,RA,TEMP,X,XCNP
+ N DIF,IEN,IND,TEMP,X,XCNP
  S ^TMP(TMPIND,$J,"NUMR")=NUM
  S X=""
@@ -143,10 +139,7 @@
  . X ^%ZOSF("TEST")
  . I $T D
- .. K RA
- .. S DIF="RA("
+ .. S DIF="^TMP(TMPIND,$J,""ROUTINE"","""_X_""","
  .. S XCNP=0
  .. X ^%ZOSF("LOAD")
- .. S ^TMP("PXRMEXCS",$J,"ROUTINE",X)=$$ROUTINE^PXRMEXCS(.RA)
- .. M ^TMP(TMPIND,$J,"ROUTINE",X)=RA
  . E  D
  .. S SERROR=1
@@ -156,8 +149,8 @@
  ;
  ;==================================================
-RMEH(FILENUM,DIQOUT,NOSTUB) ;Clear the edit history from all reminder files.
+RMEH(FILENUM,DIQOUT) ;Clear the edit history from all reminder files.
  ;Leave a stub so it can be filled in when the file is installed.
  I (FILENUM<800)!(FILENUM>811.9) Q
- N IENS,SFN,TARGET
+ N IEN,SFN,TARGET
  ;Edit History is stored in node 110 for all files, get the
  ;subfile number.
@@ -169,5 +162,4 @@
  F  S IENS=$O(DIQOUT(SFN,IENS)) Q:IENS=""  K DIQOUT(SFN,IENS)
  ;Create a stub for the install.
- I $G(NOSTUB) Q
  S IENS="1,"_$O(DIQOUT(FILENUM,""))
  S DIQOUT(SFN,IENS,.01)=$$FMTE^XLFDT($$NOW^XLFDT,"5Z")
Index: FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMEXSI.m
===================================================================
--- FOIAVistA/trunk/r/CLINICAL_REMINDERS-PXRM/PXRMEXSI.m	(revision 631)
+++ FOIAVistA/tag/r/CLINICAL_REMINDERS-PXRM/PXRMEXSI.m	(revision 636)
@@ -1,10 +1,62 @@
-PXRMEXSI ; SLC/PKR/PJH - Silent repository entry install. ;09/28/2007
- ;;2.0;CLINICAL REMINDERS;**6**;Feb 04, 2005;Build 123
+PXRMEXSI ; SLC/PKR/PJH - Silent repository entry install. ;12/22/2004
+ ;;2.0;CLINICAL REMINDERS;;Feb 04, 2005
+ ;
+ ;===================================================
+BUILD ;Build list manager workfile from ^TMP("PXRMEXTMP" (see ^PXRMEXLB)
+ N DDATA,DDLG,IND,JND,NLINE,NSEL
+ S NLINE=0,NSEL=0
+ S DDLG=$G(^TMP("PXRMEXTMP",$J,"PXRMDNAM")) Q:DDLG=""
+ ;
+ ;Save reminder dialog
+ S DDATA=^TMP("PXRMEXTMP",$J,"DLOC",DDLG)
+ S IND=$P(DDATA,U,3),JND=$P(DDATA,U,4)
+ D DSAVE(DDLG,IND,JND)
+ ;
+ ;Process sub-components
+ I $D(^TMP("PXRMEXTMP",$J,"DREPL",DDLG))>0 D DREPL(DDLG)
+ D DCMP(DDLG)
+ Q
+ ;
+ ;===================================================
+DCMP(DLG) ;Search for dialog components
+ N DDLG,DEND,DNAM,DSEQ,DSTRT,IND,JND
+ S DSEQ=0
+ F  S DSEQ=$O(^TMP("PXRMEXTMP",$J,"DMAP",DLG,DSEQ)) Q:'DSEQ  D
+ . S DDATA=^TMP("PXRMEXTMP",$J,"DMAP",DLG,DSEQ)
+ . S DNAM=$P(DDATA,U),DSTRT=$P(DDATA,U,2),DEND=$P(DDATA,U,3) Q:DNAM=""
+ . S IND=$P(DDATA,U,4),JND=$P(DDATA,U,5)
+ .;Save line in workfile
+ . D DSAVE(DNAM,IND,JND)
+ .;
+ . I $D(^TMP("PXRMEXTMP",$J,"DREPL",DNAM))>0 D DREPL(DNAM)
+ .;Process any sub-components
+ . I $D(^TMP("PXRMEXTMP",$J,"DMAP",DNAM)) D DCMP(DNAM)
+ Q
+ ;
+ ;===================================================
+DREPL(DLG,LEV) ;
+ N DDATA,DDLG,DEND,DNAM,DSEQ,DSTRT,IND,JND
+ S DDATA=^TMP("PXRMEXTMP",$J,"DREPL",DLG)
+ S DNAM=$P(DDATA,U),DSTRT=$P(DDATA,U,2),DEND=$P(DDATA,U,3) Q:DNAM=""
+ S IND=$P(DDATA,U,4),JND=$P(DDATA,U,5)
+ ;Save line in workfile
+ D DSAVE(DNAM,IND,JND)
+ I $D(^TMP("PXRMEXTMP",$J,"DMAP",DNAM)) D DCMP(DNAM)
+ Q
+ ;===================================================
+DSAVE(DNAM,IND,JND) ;Update workfile
+ ;Ignore national prompts
+ I $$PXRM^PXRMEXID(DNAM) Q
+ N DEXIST
+ S NSEL=NSEL+1
+ ;Check if dialog exists
+ S DEXIST=$$EXISTS^PXRMEXIU(801.41,DNAM)
+ ;Store the file number, start and stop line in the exchange file.
+ S ^TMP("PXRMEXLD",$J,"SEL",NSEL)=FILENUM_U_IND_U_JND_U_DEXIST
+ Q
  ;
  ;===================================================
 INITMPG ;Initialize ^TMP arrays.
- K ^TMP("PXRMEXFND",$J)
  K ^TMP("PXRMEXIA",$J)
- K ^TMP("PXRMEXIAD",$J)
  K ^TMP("PXRMEXLC",$J)
  K ^TMP("PXRMEXLD",$J)
@@ -13,72 +65,55 @@
  ;
  ;===================================================
-INSCOM(PXRMRIEN,ACTION,IND,TEMP,REMNAME,HISTSUB) ;Install component IND
- ;of PXRMRIEN.
- N ATTR,END,EXISTS,FILENUM,IND120,JND120,NAME
- N PT01,RTN,SAME,START,TEXT
+INSCOM(PXRMRIEN,IND,TEMP,REMNAME) ;Install component IND of PXRMRIEN.
+ N ACTION,ATTR,END,EXISTS,FILENUM,IND120,JND120,NAME
+ N PT01,RTN,START
  S FILENUM=$P(TEMP,U,1),EXISTS=$P(TEMP,U,4)
  S IND120=$P(TEMP,U,2),JND120=$P(TEMP,U,3)
- I (IND120="")!(JND120="") Q
  S TEMP=^PXD(811.8,PXRMRIEN,120,IND120,1,JND120,0)
- ;If the component does not exist then the action has to be "I".
- ;If the component exists and the action is "I" change it to "O".
- ;If the component exists and the action is "M" leave it "M".
- ;If the component exists and the action is "O" leave it "O".
- S ACTION=$S('EXISTS:"I",ACTION="I":"O",1:ACTION)
- S SAME=0
+ I (FILENUM=801.41)!(FILENUM=811.5) S ACTION=$S(EXISTS:"M",1:"I")
+ E  S ACTION=$S(EXISTS:"O",1:"I")
  S START=$P(TEMP,U,2)
  S END=$P(TEMP,U,3)
+ S TEMP=^PXD(811.8,PXRMRIEN,100,START,0)
  I FILENUM=0 D
  . D RTNLD^PXRMEXIC(PXRMRIEN,START,END,.ATTR,.RTN)
- . I EXISTS D
- .. D CHECKSUM^PXRMEXCS(.ATTR,START,END)
- .. S CSUM=$$RTNCS^PXRMEXCS(ATTR("NAME"))
- .. I ATTR("CHECKSUM")=CSUM S SAME=1,ACTION="S"
+ .;Save what was done for the installation summary.
  . S ^TMP("PXRMEXIA",$J,IND,"ROUTINE",ATTR("NAME"),ACTION)=""
  E  D 
- . S TEMP=^PXD(811.8,PXRMRIEN,100,START,0)
  . S PT01=$P(TEMP,"~",2)
- .;Save reminder name for dialog install.
- . I FILENUM=811.9 S REMNAME=PT01
- . D SETATTR^PXRMEXFI(.ATTR,FILENUM,PT01)
- . I EXISTS D
- .. D CHECKSUM^PXRMEXCS(.ATTR,START,END)
- .. S CSUM=$$FILE^PXRMEXCS(ATTR("FILE NUMBER"),EXISTS)
- .. I ATTR("CHECKSUM")=CSUM S SAME=1,ACTION="S"
+ . S (ATTR("NAME"),ATTR("PT01"))=PT01
+ . D SETATTR^PXRMEXFI(.ATTR,FILENUM)
  .;Save what was done for the installation summary.
- . S ^TMP(HISTSUB,$J,IND,ATTR("FILE NAME"),PT01,ACTION)=""
- ;If the packed component and the installed component are the same
- ;there is nothing to do.
- I SAME Q
+ . S ^TMP("PXRMEXIA",$J,IND,ATTR("FILE NAME"),PT01,ACTION)=""
  ;Install this component.
  I FILENUM=0 D RTNSAVE^PXRMEXIC(.RTN,ATTR("NAME"))
  E  D FILE^PXRMEXIC(PXRMRIEN,EXISTS,IND120,JND120,ACTION,.ATTR,.PXRMNMCH)
+ ;Save reminder name
+ I FILENUM=811.9 S REMNAME=PT01
+ ;If this component was not installed add to the no install message.
  Q
  ;
  ;===================================================
-INSDLG(PXRMRIEN,ACTION) ;Install dialog components directly
- ;from the "SEL" array.
- N IND,FILENUM,ITEMP,NAME,REMNAME,TEMP
- ;Build the selection array in ^TMP("PXRMEXLD",$J,"SEL"). For dialogs
- ;the selection array is: 
- ;file no.^FDA start^FDA end^EXISTS^IND120^JND120^NAME
- D BLDDISP^PXRMEXD1(0)
- ;Work through the selection array installing the dialog parts
- ;in reverse order.
- S IND=""
- F  S IND=$O(^TMP("PXRMEXLD",$J,"SEL",IND),-1) Q:(IND="")!(PXRMDONE)  D
- . S TEMP=^TMP("PXRMEXLD",$J,"SEL",IND)
- . S FILENUM=$P(TEMP,U,1),NAME=$P(TEMP,U,7)
- .;Dialog elements may be used more than once in a dialog so make sure
- .;the element has not already been installed.
- . S ITEMP=$P(TEMP,U,1)_U_$P(TEMP,U,5,6)_U_$$EXISTS^PXRMEXIU(FILENUM,NAME)
- . D INSCOM(PXRMRIEN,ACTION,IND,ITEMP,.REMNAME,"PXRMEXIAD")
+INSDLG(PXRMRIEN) ;Install dialog components (in reverse order)
+ ;
+ K ^TMP("PXRMEXSI",$J)
+ N IND,TEMP,JND120,KIDSDONE
+ ;Build list of components
+ D BUILD
+ S IND="",KIDSDONE=0
+ F  S IND=$O(^TMP("PXRMEXLD",$J,"SEL",IND),-1) Q:'IND!(KIDSDONE=1)  D
+ . S TEMP=^TMP("PXRMEXLD",$J,"SEL",IND),JND120=$P(TEMP,U,3)
+ .;Skip install if dialog occurs more than once
+ . I $D(^TMP("PXRMEXSI",$J,JND120)) Q
+ . S ^TMP("PXRMEXSI",$J,JND120)=""
+ .;Silent Dialog Install
+ . D INSCOM(PXRMRIEN,IND,TEMP,.REMNAME)
+ K ^TMP("PXRMEXSI",$J)
  Q
  ;
  ;===================================================
-INSTALL(PXRMRIEN,ACTION,NOR) ;Install all components in a repository entry.
+INSTALL(PXRMRIEN,NOR) ;Install all components in a repository entry.
  ;If NOR is true do not install routines.
- N DNAME,FILENUM,IND,PXRMDONE,PXRMNMCH,REMNAME,TEMP
- S PXRMDONE=0
+ N DNAME,FILENUM,IND,PXRMNMCH,REMNAME,TEMP
  S NOR=$G(NOR)
  ;Initialize ^TMP globals.
@@ -91,11 +126,10 @@
  ;Build the selectable list.
  D CDISP^PXRMEXLC(PXRMRIEN)
- ;Set the install date and time and type.
+ ;Set the install date and time.
  S ^TMP("PXRMEXIA",$J,"DT")=$$NOW^XLFDT
- S ^TMP("PXRMEXIA",$J,"TYPE")="SILENT"
  ;Initialize the name change storage.
  K PXRMNMCH
  S IND=0
- F  S IND=$O(^TMP("PXRMEXLC",$J,"SEL",IND)) Q:(IND="")!(PXRMDONE)  D
+ F  S IND=$O(^TMP("PXRMEXLC",$J,"SEL",IND)) Q:+IND=0  D
  . S TEMP=^TMP("PXRMEXLC",$J,"SEL",IND)
  . S FILENUM=$P(TEMP,U,1)
@@ -103,7 +137,7 @@
  . I FILENUM=0,NOR Q
  . ;Install dialog components
- . I FILENUM=801.41 N PXRMDONE S PXRMDONE=0 D INSDLG(PXRMRIEN,ACTION) Q
+ . I FILENUM=801.41 N PXRMDONE S PXRMDONE=0 D INSDLG(PXRMRIEN) Q
  . ;Install component
- . E  D INSCOM(PXRMRIEN,ACTION,IND,TEMP,.REMNAME,"PXRMEXIA")
+ . E  D INSCOM(PXRMRIEN,IND,TEMP,.REMNAME)
  ;
  ;Get the dialog name
